<?php
require_once("utility.php");
class Format {
  public static function createTable($array) {
    $data = "";
    $data .= "<table>\n";

    $data .= "<tr>";
    foreach ($array['0'] as $j => $val) {
      $data .= "<th>".$array['0'][$j]."</th>";
    }
    $data .= "</tr>\n";

    $format = "<td>%s</td>";
    for ($i = 1; $i < count($array); ++$i) {
      if ($i%2 == 1) {
        $data .= "<tr class=oddNumberRow>";
      } else {
        $data .= "<tr class=evenNumberRow>";
      }

      foreach ($array[$i] as $j => $val) {
        $data .= sprintf($format, number_format($array[$i][$j], 0, '', ','));
      }

      $data .= "</tr>\n";
    }

    $data .= "</table>\n";

    return $data;
  }

  public static function createCSV($array) {
    $data = "";
    foreach ($array['0'] as $j => $val) {
      $data .= $array['0'][$j].",";
    }
    $data .= "\n";

    $format = "%s,";
    for ($i = 1; $i < count($array); ++$i) {
      foreach ($array[$i] as $j => $val) {
        $data .= sprintf($format, $array[$i][$j]);
      }
      $data .= "\n";
    }

    return $data;
  }

  public static function createText($array) {
    $data = "";
    $data .= "<pre>\n";

    $tableArray = array();
    $widthArray = array();

    $i = 0;
    foreach ($array[$i] as $j => $val) {
      $tableArray[$i][$j] = $array[$i][$j];
      $widthArray[$j] = strlen((string)$tableArray[$i][$j]);
    }


    for ($i = 1; $i < count($array); ++$i) {
      foreach ($array[$i] as $j => $val) {
        $tableArray[$i][$j] = number_format($array[$i][$j], 0, '', ',');
        if ($widthArray[$j] < strlen((string)$tableArray[$i][$j])) {
          $widthArray[$j] = strlen((string)$tableArray[$i][$j]);
        }
      }
    }

    $k = 1;
    $i = 0;
    $bar = "";
    foreach ($array[$i] as $j => $val) {
      $data .= sprintf("%".$widthArray[$j]."s", $tableArray[$i][$j]);
      for($x = 0; $x < $widthArray[$j]; $x++) {
        $bar .= "=";
      }
      if ($k < count($array[$i])) {
        $data .= " | ";
        $bar .= "===";
        $k++;
      }
    }
    $data .= "\n".$bar."\n";

    for ($i = 1; $i < count($array); ++$i) {
      $k = 1;
      foreach ($array[$i] as $j => $val) {
        $data .= sprintf("%".$widthArray[$j]."s", $tableArray[$i][$j]);

        if ($k < count($array[$i])) {
          $data .= " | ";
          $k++;
        }
      }
      $data .= "\n";
    }

    $data .= "</pre>\n";

    return $data;
  }

  public static function createResultsTable($array) {
    $i = 1;
    $data = "";
    $data .= "<table>\n";
    $data .= "<tr><th /></th><th>Current</th><th>Target</th><th>Delta</th></tr>\n";

    $format = "<tr class=%s><td>%s</td><td>%s</td><td>%s</td><td>%s</td></tr>\n";
    foreach ($array['label'] as $j => $val) {
      if ($i%2 == 1) {
        $style = "oddNumberRow";
      } else {
        $style = "evenNumberRow";
      }

      $label = $array['label'][$j];
      $current = number_format($array['val'][$j], 0, '', ',');
      $target = number_format($array['tval'][$j], 0, '', ',');
      $delta = number_format($array['tval'][$j] - $array['val'][$j], 0, '', ',');
// number_format(Utility::delta($array,$i), 0, '', ',');

      $data .= sprintf($format, $style, $label, $current, $target, $delta);
      $i++;
    }

    $data .= "</table>\n";

    return $data;
  }
}
?>